------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Item_Delegates;
with Qt4.Abstract_Item_Models;
with Qt4.Abstract_Item_Views;
with Qt4.Completers;
with Qt4.Line_Edits;
with Qt4.Validators;
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Combo_Box_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Combo_Box_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Combo_Boxes is

   procedure addItem_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Text : not null access constant Qt4.Strings.Internals.QString;
     User_Data : not null access constant Qt4.Variants.Internals.QVariant);
   pragma Import (C, addItem_1_wrapper,
                     "__Qt4Ada_QComboBox_addItem_1_wrapper");

   procedure addItem_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Icon : not null access constant Qt4.Icons.Internals.QIcon;
     Text : not null access constant Qt4.Strings.Internals.QString;
     User_Data : not null access constant Qt4.Variants.Internals.QVariant);
   pragma Import (C, addItem_0_wrapper,
                     "__Qt4Ada_QComboBox_addItem_0_wrapper");

   procedure addItems_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Texts : not null access constant Qt4.String_Lists.Internals.QStringList);
   pragma Import (C, addItems_0_wrapper,
                     "__Qt4Ada_QComboBox_addItems_0_wrapper");

   function completer_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, completer_0_wrapper,
                     "__Qt4Ada_QComboBox_completer_0_wrapper");

   function count_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, count_0_wrapper,
                     "__Qt4Ada_QComboBox_count_0_wrapper");

   function currentIndex_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, currentIndex_0_wrapper,
                     "__Qt4Ada_QComboBox_currentIndex_0_wrapper");

   procedure currentText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, currentText_0_wrapper,
                     "__Qt4Ada_QComboBox_currentText_0_wrapper");

   function duplicatesEnabled_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, duplicatesEnabled_0_wrapper,
                     "__Qt4Ada_QComboBox_duplicatesEnabled_0_wrapper");

   function hasFrame_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, hasFrame_0_wrapper,
                     "__Qt4Ada_QComboBox_hasFrame_0_wrapper");

   procedure iconSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Sizes.Internals.QSize);
   pragma Import (C, iconSize_0_wrapper,
                     "__Qt4Ada_QComboBox_iconSize_0_wrapper");

   procedure insertItem_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Index : Qt4.Q_Integer;
     Text : not null access constant Qt4.Strings.Internals.QString;
     User_Data : not null access constant Qt4.Variants.Internals.QVariant);
   pragma Import (C, insertItem_1_wrapper,
                     "__Qt4Ada_QComboBox_insertItem_1_wrapper");

   procedure insertItem_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Index : Qt4.Q_Integer;
     Icon : not null access constant Qt4.Icons.Internals.QIcon;
     Text : not null access constant Qt4.Strings.Internals.QString;
     User_Data : not null access constant Qt4.Variants.Internals.QVariant);
   pragma Import (C, insertItem_0_wrapper,
                     "__Qt4Ada_QComboBox_insertItem_0_wrapper");

   function isEditable_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isEditable_0_wrapper,
                     "__Qt4Ada_QComboBox_isEditable_0_wrapper");

   function itemDelegate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, itemDelegate_0_wrapper,
                     "__Qt4Ada_QComboBox_itemDelegate_0_wrapper");

   procedure itemIcon_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Index : Qt4.Q_Integer;
     Returns : not null access Qt4.Icons.Internals.QIcon);
   pragma Import (C, itemIcon_0_wrapper,
                     "__Qt4Ada_QComboBox_itemIcon_0_wrapper");

   procedure itemText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Index : Qt4.Q_Integer;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, itemText_0_wrapper,
                     "__Qt4Ada_QComboBox_itemText_0_wrapper");

   function lineEdit_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, lineEdit_0_wrapper,
                     "__Qt4Ada_QComboBox_lineEdit_0_wrapper");

   function maxCount_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, maxCount_0_wrapper,
                     "__Qt4Ada_QComboBox_maxCount_0_wrapper");

   function maxVisibleItems_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, maxVisibleItems_0_wrapper,
                     "__Qt4Ada_QComboBox_maxVisibleItems_0_wrapper");

   function minimumContentsLength_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, minimumContentsLength_0_wrapper,
                     "__Qt4Ada_QComboBox_minimumContentsLength_0_wrapper");

   function model_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, model_0_wrapper,
                     "__Qt4Ada_QComboBox_model_0_wrapper");

   function modelColumn_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, modelColumn_0_wrapper,
                     "__Qt4Ada_QComboBox_modelColumn_0_wrapper");

   procedure removeItem_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Index : Qt4.Q_Integer);
   pragma Import (C, removeItem_0_wrapper,
                     "__Qt4Ada_QComboBox_removeItem_0_wrapper");

   procedure rootModelIndex_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Model_Indices.Internals.QModelIndex);
   pragma Import (C, rootModelIndex_0_wrapper,
                     "__Qt4Ada_QComboBox_rootModelIndex_0_wrapper");

   procedure setCompleter_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     C : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setCompleter_0_wrapper,
                     "__Qt4Ada_QComboBox_setCompleter_0_wrapper");

   procedure setDuplicatesEnabled_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Enable : Qt4.bool);
   pragma Import (C, setDuplicatesEnabled_0_wrapper,
                     "__Qt4Ada_QComboBox_setDuplicatesEnabled_0_wrapper");

   procedure setEditable_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Editable : Qt4.bool);
   pragma Import (C, setEditable_0_wrapper,
                     "__Qt4Ada_QComboBox_setEditable_0_wrapper");

   procedure setFrame_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Enable : Qt4.bool);
   pragma Import (C, setFrame_0_wrapper,
                     "__Qt4Ada_QComboBox_setFrame_0_wrapper");

   procedure setItemDelegate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Delegate : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setItemDelegate_0_wrapper,
                     "__Qt4Ada_QComboBox_setItemDelegate_0_wrapper");

   procedure setIconSize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Size : not null access constant Qt4.Sizes.Internals.QSize);
   pragma Import (C, setIconSize_0_wrapper,
                     "__Qt4Ada_QComboBox_setIconSize_0_wrapper");

   procedure setItemIcon_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Index : Qt4.Q_Integer;
     Icon : not null access constant Qt4.Icons.Internals.QIcon);
   pragma Import (C, setItemIcon_0_wrapper,
                     "__Qt4Ada_QComboBox_setItemIcon_0_wrapper");

   procedure setItemText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Index : Qt4.Q_Integer;
     Text : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setItemText_0_wrapper,
                     "__Qt4Ada_QComboBox_setItemText_0_wrapper");

   procedure setLineEdit_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Edit : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setLineEdit_0_wrapper,
                     "__Qt4Ada_QComboBox_setLineEdit_0_wrapper");

   procedure setMaxCount_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Max : Qt4.Q_Integer);
   pragma Import (C, setMaxCount_0_wrapper,
                     "__Qt4Ada_QComboBox_setMaxCount_0_wrapper");

   procedure setMaxVisibleItems_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Max_Items : Qt4.Q_Integer);
   pragma Import (C, setMaxVisibleItems_0_wrapper,
                     "__Qt4Ada_QComboBox_setMaxVisibleItems_0_wrapper");

   procedure setMinimumContentsLength_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Characters : Qt4.Q_Integer);
   pragma Import (C, setMinimumContentsLength_0_wrapper,
                     "__Qt4Ada_QComboBox_setMinimumContentsLength_0_wrapper");

   procedure setModel_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Model : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setModel_0_wrapper,
                     "__Qt4Ada_QComboBox_setModel_0_wrapper");

   procedure setModelColumn_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Visible_Column : Qt4.Q_Integer);
   pragma Import (C, setModelColumn_0_wrapper,
                     "__Qt4Ada_QComboBox_setModelColumn_0_wrapper");

   procedure setRootModelIndex_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Index : not null access constant Qt4.Model_Indices.Internals.QModelIndex);
   pragma Import (C, setRootModelIndex_0_wrapper,
                     "__Qt4Ada_QComboBox_setRootModelIndex_0_wrapper");

   procedure setValidator_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     V : not null access constant Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setValidator_0_wrapper,
                     "__Qt4Ada_QComboBox_setValidator_0_wrapper");

   procedure setView_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Item_View : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setView_0_wrapper,
                     "__Qt4Ada_QComboBox_setView_0_wrapper");

   function validator_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, validator_0_wrapper,
                     "__Qt4Ada_QComboBox_validator_0_wrapper");

   function view_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, view_0_wrapper,
                     "__Qt4Ada_QComboBox_view_0_wrapper");

   procedure clear_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, clear_0_wrapper,
                     "__Qt4Ada_QComboBox_clear_0_wrapper");

   procedure clearEditText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, clearEditText_0_wrapper,
                     "__Qt4Ada_QComboBox_clearEditText_0_wrapper");

   procedure setCurrentIndex_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Index : Qt4.Q_Integer);
   pragma Import (C, setCurrentIndex_0_wrapper,
                     "__Qt4Ada_QComboBox_setCurrentIndex_0_wrapper");

   procedure setEditText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Text : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setEditText_0_wrapper,
                     "__Qt4Ada_QComboBox_setEditText_0_wrapper");

   function findText_wrapper
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Text  : not null access Qt4.Strings.Internals.QString;
     Flags : Qt4.Match_Flags)
       return Interfaces.C.int;
   pragma Import (C, findText_wrapper, "__Qt4Ada_QComboBox_findText_wrapper");

   function Find_Text
    (Self  : not null access Qt4.Combo_Boxes.Q_Combo_Box'Class;
     Text  : Qt4.Strings.Q_String;
     Flags : Qt4.Match_Flags := +Match_Exactly+Match_Case_Sensitive)
       return Qt4.Q_Integer
   is
   begin
     return Qt4.Q_Integer
             (findText_wrapper
               (Self.QObject_View,
                Qt4.Strings.Internals.QString_View (Text),
                Flags));
   end Find_Text;

   pragma Style_Checks ("N");

   --------------
   -- Add_Item --
   --------------

   procedure Add_Item
    (Self : not null access Q_Combo_Box'Class;
     Text : Qt4.Strings.Q_String;
     User_Data : Qt4.Variants.Q_Variant
       := Qt4.Variants.Create)
   is
   begin
      addItem_1_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Text),
        Qt4.Variants.Internals.QVariant_View (User_Data));
   end Add_Item;

   --------------
   -- Add_Item --
   --------------

   procedure Add_Item
    (Self : not null access Q_Combo_Box'Class;
     Icon : Qt4.Icons.Q_Icon;
     Text : Qt4.Strings.Q_String;
     User_Data : Qt4.Variants.Q_Variant
       := Qt4.Variants.Create)
   is
   begin
      addItem_0_wrapper
       (Self.QObject_View,
        Qt4.Icons.Internals.QIcon_View (Icon),
        Qt4.Strings.Internals.QString_View (Text),
        Qt4.Variants.Internals.QVariant_View (User_Data));
   end Add_Item;

   ---------------
   -- Add_Items --
   ---------------

   procedure Add_Items
    (Self : not null access Q_Combo_Box'Class;
     Texts : Qt4.String_Lists.Q_String_List)
   is
   begin
      addItems_0_wrapper
       (Self.QObject_View,
        Qt4.String_Lists.Internals.QStringList_View (Texts));
   end Add_Items;

   ---------------
   -- Completer --
   ---------------

   function Completer
    (Self : not null access constant Q_Combo_Box'Class)
       return not null access Qt4.Completers.Q_Completer'Class
   is
   begin
      return
        Qt4.Completers.Q_Completer'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (completer_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Completer;

   -----------
   -- Count --
   -----------

   function Count
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        count_0_wrapper
         (Self.QObject_View);
   end Count;

   -------------------
   -- Current_Index --
   -------------------

   function Current_Index
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        currentIndex_0_wrapper
         (Self.QObject_View);
   end Current_Index;

   ------------------
   -- Current_Text --
   ------------------

   function Current_Text
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      currentText_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Current_Text;

   ------------------------
   -- Duplicates_Enabled --
   ------------------------

   function Duplicates_Enabled
    (Self : not null access constant Q_Combo_Box'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (duplicatesEnabled_0_wrapper
           (Self.QObject_View));
   end Duplicates_Enabled;

   ---------------
   -- Has_Frame --
   ---------------

   function Has_Frame
    (Self : not null access constant Q_Combo_Box'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasFrame_0_wrapper
           (Self.QObject_View));
   end Has_Frame;

   ---------------
   -- Icon_Size --
   ---------------

   function Icon_Size
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Sizes.Q_Size
   is
      Returns : Qt4.Sizes.Q_Size;

   begin
      iconSize_0_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (Returns));

      return Returns;
   end Icon_Size;

   -----------------
   -- Insert_Item --
   -----------------

   procedure Insert_Item
    (Self : not null access Q_Combo_Box'Class;
     Index : Qt4.Q_Integer;
     Text : Qt4.Strings.Q_String;
     User_Data : Qt4.Variants.Q_Variant
       := Qt4.Variants.Create)
   is
   begin
      insertItem_1_wrapper
       (Self.QObject_View,
        Index,
        Qt4.Strings.Internals.QString_View (Text),
        Qt4.Variants.Internals.QVariant_View (User_Data));
   end Insert_Item;

   -----------------
   -- Insert_Item --
   -----------------

   procedure Insert_Item
    (Self : not null access Q_Combo_Box'Class;
     Index : Qt4.Q_Integer;
     Icon : Qt4.Icons.Q_Icon;
     Text : Qt4.Strings.Q_String;
     User_Data : Qt4.Variants.Q_Variant
       := Qt4.Variants.Create)
   is
   begin
      insertItem_0_wrapper
       (Self.QObject_View,
        Index,
        Qt4.Icons.Internals.QIcon_View (Icon),
        Qt4.Strings.Internals.QString_View (Text),
        Qt4.Variants.Internals.QVariant_View (User_Data));
   end Insert_Item;

   -----------------
   -- Is_Editable --
   -----------------

   function Is_Editable
    (Self : not null access constant Q_Combo_Box'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isEditable_0_wrapper
           (Self.QObject_View));
   end Is_Editable;

   -------------------
   -- Item_Delegate --
   -------------------

   function Item_Delegate
    (Self : not null access constant Q_Combo_Box'Class)
       return not null access Qt4.Abstract_Item_Delegates.Q_Abstract_Item_Delegate'Class
   is
   begin
      return
        Qt4.Abstract_Item_Delegates.Q_Abstract_Item_Delegate'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (itemDelegate_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Item_Delegate;

   ---------------
   -- Item_Icon --
   ---------------

   function Item_Icon
    (Self : not null access constant Q_Combo_Box'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Icons.Q_Icon
   is
      Returns : Qt4.Icons.Q_Icon;

   begin
      itemIcon_0_wrapper
       (Self.QObject_View,
        Index,
        Qt4.Icons.Internals.QIcon_View (Returns));

      return Returns;
   end Item_Icon;

   ---------------
   -- Item_Text --
   ---------------

   function Item_Text
    (Self : not null access constant Q_Combo_Box'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      itemText_0_wrapper
       (Self.QObject_View,
        Index,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Item_Text;

   ---------------
   -- Line_Edit --
   ---------------

   function Line_Edit
    (Self : not null access constant Q_Combo_Box'Class)
       return not null access Qt4.Line_Edits.Q_Line_Edit'Class
   is
   begin
      return
        Qt4.Line_Edits.Q_Line_Edit'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (lineEdit_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Line_Edit;

   ---------------
   -- Max_Count --
   ---------------

   function Max_Count
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        maxCount_0_wrapper
         (Self.QObject_View);
   end Max_Count;

   -----------------------
   -- Max_Visible_Items --
   -----------------------

   function Max_Visible_Items
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        maxVisibleItems_0_wrapper
         (Self.QObject_View);
   end Max_Visible_Items;

   -----------------------------
   -- Minimum_Contents_Length --
   -----------------------------

   function Minimum_Contents_Length
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        minimumContentsLength_0_wrapper
         (Self.QObject_View);
   end Minimum_Contents_Length;

   -----------
   -- Model --
   -----------

   function Model
    (Self : not null access constant Q_Combo_Box'Class)
       return not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class
   is
   begin
      return
        Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (model_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Model;

   ------------------
   -- Model_Column --
   ------------------

   function Model_Column
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        modelColumn_0_wrapper
         (Self.QObject_View);
   end Model_Column;

   -----------------
   -- Remove_Item --
   -----------------

   procedure Remove_Item
    (Self : not null access Q_Combo_Box'Class;
     Index : Qt4.Q_Integer)
   is
   begin
      removeItem_0_wrapper
       (Self.QObject_View,
        Index);
   end Remove_Item;

   ----------------------
   -- Root_Model_Index --
   ----------------------

   function Root_Model_Index
    (Self : not null access constant Q_Combo_Box'Class)
       return Qt4.Model_Indices.Q_Model_Index
   is
      Returns : Qt4.Model_Indices.Q_Model_Index;

   begin
      rootModelIndex_0_wrapper
       (Self.QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Returns));

      return Returns;
   end Root_Model_Index;

   -------------------
   -- Set_Completer --
   -------------------

   procedure Set_Completer
    (Self : not null access Q_Combo_Box'Class;
     C : not null access Qt4.Completers.Q_Completer'Class)
   is
   begin
      setCompleter_0_wrapper
       (Self.QObject_View,
        C.QObject_View);
   end Set_Completer;

   ----------------------------
   -- Set_Duplicates_Enabled --
   ----------------------------

   procedure Set_Duplicates_Enabled
    (Self : not null access Q_Combo_Box'Class;
     Enable : Standard.Boolean)
   is
   begin
      setDuplicatesEnabled_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Enable));
   end Set_Duplicates_Enabled;

   ------------------
   -- Set_Editable --
   ------------------

   procedure Set_Editable
    (Self : not null access Q_Combo_Box'Class;
     Editable : Standard.Boolean)
   is
   begin
      setEditable_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Editable));
   end Set_Editable;

   ---------------
   -- Set_Frame --
   ---------------

   procedure Set_Frame
    (Self : not null access Q_Combo_Box'Class;
     Enable : Standard.Boolean)
   is
   begin
      setFrame_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Enable));
   end Set_Frame;

   -----------------------
   -- Set_Item_Delegate --
   -----------------------

   procedure Set_Item_Delegate
    (Self : not null access Q_Combo_Box'Class;
     Delegate : not null access Qt4.Abstract_Item_Delegates.Q_Abstract_Item_Delegate'Class)
   is
   begin
      setItemDelegate_0_wrapper
       (Self.QObject_View,
        Delegate.QObject_View);
   end Set_Item_Delegate;

   -------------------
   -- Set_Icon_Size --
   -------------------

   procedure Set_Icon_Size
    (Self : not null access Q_Combo_Box'Class;
     Size : Qt4.Sizes.Q_Size)
   is
   begin
      setIconSize_0_wrapper
       (Self.QObject_View,
        Qt4.Sizes.Internals.QSize_View (Size));
   end Set_Icon_Size;

   -------------------
   -- Set_Item_Icon --
   -------------------

   procedure Set_Item_Icon
    (Self : not null access Q_Combo_Box'Class;
     Index : Qt4.Q_Integer;
     Icon : Qt4.Icons.Q_Icon)
   is
   begin
      setItemIcon_0_wrapper
       (Self.QObject_View,
        Index,
        Qt4.Icons.Internals.QIcon_View (Icon));
   end Set_Item_Icon;

   -------------------
   -- Set_Item_Text --
   -------------------

   procedure Set_Item_Text
    (Self : not null access Q_Combo_Box'Class;
     Index : Qt4.Q_Integer;
     Text : Qt4.Strings.Q_String)
   is
   begin
      setItemText_0_wrapper
       (Self.QObject_View,
        Index,
        Qt4.Strings.Internals.QString_View (Text));
   end Set_Item_Text;

   -------------------
   -- Set_Line_Edit --
   -------------------

   procedure Set_Line_Edit
    (Self : not null access Q_Combo_Box'Class;
     Edit : not null access Qt4.Line_Edits.Q_Line_Edit'Class)
   is
   begin
      setLineEdit_0_wrapper
       (Self.QObject_View,
        Edit.QObject_View);
   end Set_Line_Edit;

   -------------------
   -- Set_Max_Count --
   -------------------

   procedure Set_Max_Count
    (Self : not null access Q_Combo_Box'Class;
     Max : Qt4.Q_Integer)
   is
   begin
      setMaxCount_0_wrapper
       (Self.QObject_View,
        Max);
   end Set_Max_Count;

   ---------------------------
   -- Set_Max_Visible_Items --
   ---------------------------

   procedure Set_Max_Visible_Items
    (Self : not null access Q_Combo_Box'Class;
     Max_Items : Qt4.Q_Integer)
   is
   begin
      setMaxVisibleItems_0_wrapper
       (Self.QObject_View,
        Max_Items);
   end Set_Max_Visible_Items;

   ---------------------------------
   -- Set_Minimum_Contents_Length --
   ---------------------------------

   procedure Set_Minimum_Contents_Length
    (Self : not null access Q_Combo_Box'Class;
     Characters : Qt4.Q_Integer)
   is
   begin
      setMinimumContentsLength_0_wrapper
       (Self.QObject_View,
        Characters);
   end Set_Minimum_Contents_Length;

   ---------------
   -- Set_Model --
   ---------------

   procedure Set_Model
    (Self : not null access Q_Combo_Box'Class;
     Model : not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class)
   is
   begin
      setModel_0_wrapper
       (Self.QObject_View,
        Model.QObject_View);
   end Set_Model;

   ----------------------
   -- Set_Model_Column --
   ----------------------

   procedure Set_Model_Column
    (Self : not null access Q_Combo_Box'Class;
     Visible_Column : Qt4.Q_Integer)
   is
   begin
      setModelColumn_0_wrapper
       (Self.QObject_View,
        Visible_Column);
   end Set_Model_Column;

   --------------------------
   -- Set_Root_Model_Index --
   --------------------------

   procedure Set_Root_Model_Index
    (Self : not null access Q_Combo_Box'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
   is
   begin
      setRootModelIndex_0_wrapper
       (Self.QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Index));
   end Set_Root_Model_Index;

   -------------------
   -- Set_Validator --
   -------------------

   procedure Set_Validator
    (Self : not null access Q_Combo_Box'Class;
     V : not null access constant Qt4.Validators.Q_Validator'Class)
   is
   begin
      setValidator_0_wrapper
       (Self.QObject_View,
        V.QObject_View);
   end Set_Validator;

   --------------
   -- Set_View --
   --------------

   procedure Set_View
    (Self : not null access Q_Combo_Box'Class;
     Item_View : not null access Qt4.Abstract_Item_Views.Q_Abstract_Item_View'Class)
   is
   begin
      setView_0_wrapper
       (Self.QObject_View,
        Item_View.QObject_View);
   end Set_View;

   ---------------
   -- Validator --
   ---------------

   function Validator
    (Self : not null access constant Q_Combo_Box'Class)
       return not null access Qt4.Validators.Q_Validator'Class
   is
   begin
      return
        Qt4.Validators.Q_Validator'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (validator_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Validator;

   ----------
   -- View --
   ----------

   function View
    (Self : not null access constant Q_Combo_Box'Class)
       return not null access Qt4.Abstract_Item_Views.Q_Abstract_Item_View'Class
   is
   begin
      return
        Qt4.Abstract_Item_Views.Q_Abstract_Item_View'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (view_0_wrapper
             (Self.QObject_View)).all)'Access;
   end View;

   -----------
   -- Clear --
   -----------

   procedure Clear
    (Self : not null access Q_Combo_Box'Class)
   is
   begin
      clear_0_wrapper
       (Self.QObject_View);
   end Clear;

   ---------------------
   -- Clear_Edit_Text --
   ---------------------

   procedure Clear_Edit_Text
    (Self : not null access Q_Combo_Box'Class)
   is
   begin
      clearEditText_0_wrapper
       (Self.QObject_View);
   end Clear_Edit_Text;

   -----------------------
   -- Set_Current_Index --
   -----------------------

   procedure Set_Current_Index
    (Self : not null access Q_Combo_Box'Class;
     Index : Qt4.Q_Integer)
   is
   begin
      setCurrentIndex_0_wrapper
       (Self.QObject_View,
        Index);
   end Set_Current_Index;

   -------------------
   -- Set_Edit_Text --
   -------------------

   procedure Set_Edit_Text
    (Self : not null access Q_Combo_Box'Class;
     Text : Qt4.Strings.Q_String)
   is
   begin
      setEditText_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Text));
   end Set_Edit_Text;

end Qt4.Combo_Boxes;
